Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIDataDescriptor.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIDataDescriptor.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIDataDescriptor.cs	(revision 9363)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public abstract class UCIDataDescriptor : ResourceClassificationDataDescriptor {
+    public override string Name { get { return String.Format("{0}, {1}, {2}", Filename, Donor, Year); } }
+    public abstract string Filename { get; }
+    public abstract string Donor { get; }
+    public abstract int Year { get; }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs	(revision 9363)
@@ -0,0 +1,77 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using ICSharpCode.SharpZipLib.Zip;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class UCIInstanceProvider : ResourceClassificationInstanceProvider {
+    public override string Name {
+      get { return "UCI Problems"; }
+    }
+    public override string Description {
+      get {
+        return "";
+      }
+    }
+    public override Uri WebLink {
+      get { return new Uri("http://archive.ics.uci.edu/ml/datasets.html"); }
+    }
+    public override string ReferencePublication {
+      get { return ""; }
+    }
+
+    protected override string FileName { get { return "UCI"; } }
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      List<UCIDataDescriptor> descriptorList = new List<UCIDataDescriptor>();
+      descriptorList.Add(new Iris());
+      descriptorList.Add(new Mammography());
+      descriptorList.Add(new Parkinson());
+      descriptorList.Add(new Thyroid());
+      descriptorList.Add(new Vertebral_3C());
+      descriptorList.Add(new Wine());
+      descriptorList.Add(new WisconsinDiagnosticBreastCancer());
+      var solutionsArchiveName = GetResourceName(FileName + @"\.zip");
+      if (!String.IsNullOrEmpty(solutionsArchiveName)) {
+        using (var solutionsZipFile = new ZipInputStream(GetType().Assembly.GetManifestResourceStream(solutionsArchiveName))) {
+          IList<string> entries = new List<string>();
+          ZipEntry curEntry;
+          while ((curEntry = solutionsZipFile.GetNextEntry()) != null) {
+            entries.Add(curEntry.Name);
+          }
+          foreach (var entry in entries.OrderBy(x => x)) {
+            string filename = Path.GetFileNameWithoutExtension(entry);
+            UCIDataDescriptor desc = descriptorList.Where(x => x.Filename.Equals(filename)).FirstOrDefault();
+            if (desc != null) {
+              desc.ResourceName = entry;
+              yield return desc;
+            } else
+              throw new ArgumentNullException("No Descriptor could be found for this entry.");
+          }
+        }
+      }
+    }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Vertebral_3C.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Vertebral_3C.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Vertebral_3C.cs	(revision 9363)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Vertebral_3C : UCIDataDescriptor {
+    public override string Filename { get { return "Vertebral_3C"; } }
+    public override string Description {
+      get {
+        return "Data Set Information:" + Environment.NewLine
+        + "Biomedical data set built by Dr. Henrique da Mota during a medical residence "
+        + "period in the Group of Applied Research in Orthopaedics (GARO) of the Centre "
+        + "Médico-Chirurgical de Réadaptation des Massues, Lyon, France. The data have been "
+        + "organized in two different but related classification tasks. The first task consists "
+        + "in classifying patients as belonging to one out of three categories: Normal (100 patients), "
+        + "Disk Hernia (60 patients) or Spondylolisthesis (150 patients)." + Environment.NewLine
+        + "Each patient is represented in the data set by six biomechanical attributes derived from "
+        + "the shape and orientation of the pelvis and lumbar spine (in this order): pelvic incidence, "
+        + "pelvic tilt, lumbar lordosis angle, sacral slope, pelvic radius and grade of spondylolisthesis." + Environment.NewLine
+        + "Note: Normal has the value '0', Spondylolisthesis is '1' and Disk Hernia = '2'.";
+      }
+    }
+    public override string Donor { get { return "H. da Mota"; } }
+    public override int Year { get { return 2011; } }
+
+    protected override string TargetVariable { get { return "class"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "pelvic_incidence", "pelvic_tilt", "lumbar_lordosis_angle", "sacral_slope", "pelvic_radius", "degree_1", "class" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "pelvic_incidence", "pelvic_tilt", "lumbar_lordosis_angle", "sacral_slope", "pelvic_radius", "degree_1" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 207; } }
+    protected override int TestPartitionStart { get { return 207; } }
+    protected override int TestPartitionEnd { get { return 310; } }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Wine.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Wine.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Wine.cs	(revision 9363)
@@ -0,0 +1,68 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using System;
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Wine : UCIDataDescriptor {
+    public override string Filename { get { return "Wine"; } }
+    public override string Description {
+      get {
+        return "These data are the results of a chemical analysis of wines grown in the same region " +
+        "in Italy but derived from three different cultivars. The analysis determined the quantities " +
+        "of 13 constituents found in each of the three types of wines." + Environment.NewLine + Environment.NewLine +
+        "I think that the initial data set had around 30 variables, but for some reason I only have the " +
+        "13 dimensional version. I had a list of what the 30 or so variables were, but a.) I lost it, and b.), " +
+        "I would not know which 13 variables are included in the set." + Environment.NewLine + Environment.NewLine +
+        "The attributes are (dontated by Riccardo Leardi, riclea '@' anchem.unige.it )" + Environment.NewLine +
+        "1) Alcohol" + Environment.NewLine +
+        "2) Malic acid" + Environment.NewLine +
+        "3) Ash" + Environment.NewLine +
+        "4) Alcalinity of ash" + Environment.NewLine +
+        "5) Magnesium" + Environment.NewLine +
+        "6) Total phenols" + Environment.NewLine +
+        "7) Flavanoids" + Environment.NewLine +
+        "8) Nonflavanoid phenols" + Environment.NewLine +
+        "9) Proanthocyanins" + Environment.NewLine +
+        "10)Color intensity" + Environment.NewLine +
+        "11)Hue" + Environment.NewLine +
+        "12)OD280/OD315 of diluted wines" + Environment.NewLine +
+        "13)Proline" + Environment.NewLine + Environment.NewLine +
+        "In a classification context, this is a well posed problem with \"well behaved\" class structures. A " +
+        "good data set for first testing of a new classifier, but not very challenging. ";
+      }
+    }
+    public override string Donor { get { return "S. Aeberhard"; } }
+    public override int Year { get { return 1991; } }
+
+    protected override string TargetVariable { get { return "Class"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Alcohol", "Malic acid", "Ash", "Alcalinity of ash", "Magnesium", "Total phenols", "Flavanoids", "Nonflavanoid phenols", "Proanthocyanins", "Color intensity", "Hue", "OD280/OD315 of diluted wines", "Proline", "Class" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "Alcohol", "Malic acid", "Ash", "Alcalinity of ash", "Magnesium", "Total phenols", "Flavanoids", "Nonflavanoid phenols", "Proanthocyanins", "Color intensity", "Hue", "OD280/OD315 of diluted wines", "Proline" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 119; } }
+    protected override int TestPartitionStart { get { return 119; } }
+    protected override int TestPartitionEnd { get { return 178; } }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/WisconsinDiagnosticBreastCancer.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/WisconsinDiagnosticBreastCancer.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/WisconsinDiagnosticBreastCancer.cs	(revision 9363)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using System;
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class WisconsinDiagnosticBreastCancer : UCIDataDescriptor {
+    public override string Filename { get { return "Wisconsin Diagnostic Breast Cancer"; } }
+    public override string Description {
+      get {
+        return "Data Set Information:" + Environment.NewLine
+        + "Results:" + Environment.NewLine
+        + "- predicting field 2, diagnosis: B = benign, M = malignant" + Environment.NewLine
+        + "- sets are linearly separable using all 30 input features" + Environment.NewLine
+        + "- best predictive accuracy obtained using one separating plane" + Environment.NewLine
+        + "  in the 3-D space of Worst Area, Worst Smoothness and" + Environment.NewLine
+        + "  Mean Texture.  Estimated accuracy 97.5% using repeated" + Environment.NewLine
+        + "  10-fold crossvalidations.  Classifier has correctly" + Environment.NewLine
+        + "  diagnosed 176 consecutive new patients as of November 1995." + Environment.NewLine + Environment.NewLine
+        + "The classes have been converted in the following way" + Environment.NewLine
+        + "B = benign    = 0" + Environment.NewLine
+        + "M = malignant = 1";
+      }
+    }
+    public override string Donor { get { return "Nick Street"; } }
+    public override int Year { get { return 1995; } }
+
+    protected override string TargetVariable { get { return "Diagnosis"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "ID number", "Diagnosis", "mean radius", "mean texture", "mean perimeter", "mean area", "mean smoothness", "mean compactness", "mean concavity", "mean concave points", "mean symmetry", "mean fractal dimension", "radius SE", "texture SE", "perimeter SE", "area SE", "smoothness SE", "compactness SE", "concavity SE", "concave points SE", "symmetry SE", "fractal dimension SE", "worst radius", "worst texture", "worst perimeter", "worst area", "worst smoothness", "worst compactness", "worst concavity", "worst concave points", "worst symmetry", "worst fractal dimension" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "mean radius", "mean texture", "mean perimeter", "mean area", "mean smoothness", "mean compactness", "mean concavity", "mean concave points", "mean symmetry", "mean fractal dimension", "radius SE", "texture SE", "perimeter SE", "area SE", "smoothness SE", "compactness SE", "concavity SE", "concave points SE", "symmetry SE", "fractal dimension SE", "worst radius", "worst texture", "worst perimeter", "worst area", "worst smoothness", "worst compactness", "worst concavity", "worst concave points", "worst symmetry", "worst fractal dimension" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 380; } }
+    protected override int TestPartitionStart { get { return 380; } }
+    protected override int TestPartitionEnd { get { return 569; } }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Clustering/CSV/ClusteringCSVInstanceProvider.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Clustering/CSV/ClusteringCSVInstanceProvider.cs	(revision 8228)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Clustering/CSV/ClusteringCSVInstanceProvider.cs	(revision 9363)
@@ -21,7 +21,9 @@
 
 using System;
+using System.Collections;
 using System.Collections.Generic;
 using System.IO;
-using System.Text;
+using System.Linq;
+using HeuristicLab.Common;
 using HeuristicLab.Problems.DataAnalysis;
 
@@ -56,51 +58,68 @@
     public override IClusteringProblemData ImportData(string path) {
       var csvFileParser = new TableFileParser();
-
       csvFileParser.Parse(path);
 
-      var dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
-      var claData = new ClusteringProblemData(dataset, dataset.DoubleVariables);
+      Dataset dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
+      string targetVar = dataset.DoubleVariables.Last();
 
-      int trainingPartEnd = csvFileParser.Rows * 2 / 3;
-      claData.TrainingPartition.Start = 0;
-      claData.TrainingPartition.End = trainingPartEnd;
-      claData.TestPartition.Start = trainingPartEnd;
-      claData.TestPartition.End = csvFileParser.Rows;
-      int pos = path.LastIndexOf('\\');
-      if (pos < 0)
-        claData.Name = path;
-      else {
-        pos++;
-        claData.Name = path.Substring(pos, path.Length - pos);
+      // turn of input variables that are constant in the training partition
+      var allowedInputVars = new List<string>();
+      var trainingIndizes = Enumerable.Range(0, (csvFileParser.Rows * 2) / 3);
+      if (trainingIndizes.Count() >= 2) {
+        foreach (var variableName in dataset.DoubleVariables) {
+          if (dataset.GetDoubleValues(variableName, trainingIndizes).Range() > 0 &&
+            variableName != targetVar)
+            allowedInputVars.Add(variableName);
+        }
+      } else {
+        allowedInputVars.AddRange(dataset.DoubleVariables.Where(x => !x.Equals(targetVar)));
       }
 
-      return claData;
+      ClusteringProblemData clusteringData = new ClusteringProblemData(dataset, allowedInputVars);
+
+      int trainingPartEnd = trainingIndizes.Last();
+      clusteringData.TrainingPartition.Start = trainingIndizes.First();
+      clusteringData.TrainingPartition.End = trainingPartEnd;
+      clusteringData.TestPartition.Start = trainingPartEnd;
+      clusteringData.TestPartition.End = csvFileParser.Rows;
+
+      clusteringData.Name = Path.GetFileName(path);
+
+      return clusteringData;
     }
 
-    public override bool CanExportData {
-      get { return true; }
-    }
-    public override void ExportData(IClusteringProblemData instance, string path) {
-      var strBuilder = new StringBuilder();
-
-      foreach (var variable in instance.InputVariables) {
-        strBuilder.Append(variable + ";");
-      }
-      strBuilder.Remove(strBuilder.Length - 1, 1);
-      strBuilder.AppendLine();
-
-      var dataset = instance.Dataset;
-
-      for (int i = 0; i < dataset.Rows; i++) {
-        for (int j = 0; j < dataset.Columns; j++) {
-          strBuilder.Append(dataset.GetValue(i, j) + ";");
-        }
-        strBuilder.Remove(strBuilder.Length - 1, 1);
-        strBuilder.AppendLine();
+    protected override IClusteringProblemData ImportData(string path, DataAnalysisImportType type, TableFileParser csvFileParser) {
+      List<IList> values = csvFileParser.Values;
+      if (type.Shuffle) {
+        values = Shuffle(values);
       }
 
-      using (var writer = new StreamWriter(path)) {
-        writer.Write(strBuilder);
+      Dataset dataset = new Dataset(csvFileParser.VariableNames, values);
+      string targetVar = dataset.DoubleVariables.Last();
+
+      // turn of input variables that are constant in the training partition
+      var allowedInputVars = new List<string>();
+      int trainingPartEnd = (csvFileParser.Rows * type.TrainingPercentage) / 100;
+      var trainingIndizes = Enumerable.Range(0, trainingPartEnd);
+      if (trainingIndizes.Count() >= 2) {
+        foreach (var variableName in dataset.DoubleVariables) {
+          if (dataset.GetDoubleValues(variableName, trainingIndizes).Range() > 0 &&
+            variableName != targetVar)
+            allowedInputVars.Add(variableName);
+        }
+      } else {
+        allowedInputVars.AddRange(dataset.DoubleVariables.Where(x => !x.Equals(targetVar)));
       }
+
+      ClusteringProblemData clusteringData = new ClusteringProblemData(dataset, allowedInputVars);
+
+      clusteringData.TrainingPartition.Start = 0;
+      clusteringData.TrainingPartition.End = trainingPartEnd;
+      clusteringData.TestPartition.Start = trainingPartEnd;
+      clusteringData.TestPartition.End = csvFileParser.Rows;
+
+      clusteringData.Name = Path.GetFileName(path);
+
+      return clusteringData;
     }
   }
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Clustering/ClusteringInstanceProvider.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Clustering/ClusteringInstanceProvider.cs	(revision 8228)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Clustering/ClusteringInstanceProvider.cs	(revision 9363)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public abstract class ClusteringInstanceProvider : ProblemInstanceProvider<IClusteringProblemData> {
+  public abstract class ClusteringInstanceProvider : DataAnalysisInstanceProvider<IClusteringProblemData, DataAnalysisImportType> {
   }
 }
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisCSVFormat.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisCSVFormat.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisCSVFormat.cs	(revision 9363)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Globalization;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class DataAnalysisCSVFormat {
+    public char Separator { get; set; }
+    public NumberFormatInfo NumberFormatInfo { get; set; }
+    public DateTimeFormatInfo DateTimeFormatInfo { get; set; }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisImportType.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisImportType.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisImportType.cs	(revision 9363)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class DataAnalysisImportType {
+    public bool Shuffle { get; set; }
+    public int TrainingPercentage { get; set; }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisInstanceProvider.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisInstanceProvider.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisInstanceProvider.cs	(revision 9363)
@@ -0,0 +1,97 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.Globalization;
+using System.IO;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public abstract class DataAnalysisInstanceProvider<TData, ImportType> : ProblemInstanceProvider<TData>
+    where TData : class, IDataAnalysisProblemData
+    where ImportType : DataAnalysisImportType {
+
+
+    public TData ImportData(string path, ImportType type, DataAnalysisCSVFormat csvFormat) {
+      TableFileParser csvFileParser = new TableFileParser();
+      csvFileParser.Parse(path, csvFormat.NumberFormatInfo, csvFormat.DateTimeFormatInfo, csvFormat.Separator);
+      return ImportData(path, type, csvFileParser);
+    }
+
+    protected virtual TData ImportData(string path, ImportType type, TableFileParser csvFileParser) {
+      throw new NotSupportedException();
+    }
+
+    protected List<IList> Shuffle(List<IList> values) {
+      int count = values.First().Count;
+      int[] indices = Enumerable.Range(0, count).Shuffle(new FastRandom()).ToArray();
+      List<IList> shuffled = new List<IList>(values.Count);
+      for (int col = 0; col < values.Count; col++) {
+
+        if (values[col] is List<double>)
+          shuffled.Add(new List<double>());
+        else if (values[col] is List<DateTime>)
+          shuffled.Add(new List<DateTime>());
+        else if (values[col] is List<string>)
+          shuffled.Add(new List<string>());
+        else
+          throw new InvalidOperationException();
+
+        for (int i = 0; i < count; i++) {
+          shuffled[col].Add(values[col][indices[i]]);
+        }
+      }
+      return shuffled;
+    }
+
+    public override bool CanExportData {
+      get { return true; }
+    }
+    public override void ExportData(TData instance, string path) {
+      var strBuilder = new StringBuilder();
+      var colSep = CultureInfo.CurrentCulture.TextInfo.ListSeparator;
+      foreach (var variable in instance.Dataset.VariableNames) {
+        strBuilder.Append(variable.Replace(colSep, String.Empty) + colSep);
+      }
+      strBuilder.Remove(strBuilder.Length - colSep.Length, colSep.Length);
+      strBuilder.AppendLine();
+
+      var dataset = instance.Dataset;
+
+      for (int i = 0; i < dataset.Rows; i++) {
+        for (int j = 0; j < dataset.Columns; j++) {
+          if (j > 0) strBuilder.Append(colSep);
+          strBuilder.Append(dataset.GetValue(i, j));
+        }
+        strBuilder.AppendLine();
+      }
+
+      using (var writer = new StreamWriter(path)) {
+        writer.Write(strBuilder);
+      }
+    }
+  }
+}
